/* piciu filozofw z wykorzystaniem mutexw */

#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <limits.h>
#include <unistd.h>
#include <fcntl.h>
#include <semaphore.h>

#define IL_F 5
#define IL_ITER 10

pthread_mutex_t paleczka[IL_F];
pthread_t filozofy[IL_F];
sem_t *sem;

int los(float _min, float _max)
{
return (int)(rand()*(_max-_min + 1)/INT_MAX + _min );
}

void * filozof (void *arg)
{
  int nr = *((int *) arg);
  int ii;
  srand(pthread_self());
  pthread_cleanup_push (&free, arg);
  for (ii = 0; ii < IL_ITER; ii++)
    {
      printf ("Filozof nr %d (%d raz) bdzie jad ...\n", nr, ii+1);
      sem_wait(sem);
      pthread_mutex_lock (&paleczka[nr]);
      //Program niepoprawny, w tym miejscu moemy czeka dowoln chwil wtedy wszyscy filozofowie wezm paeczk.
      sleep(1);
      pthread_mutex_lock (&paleczka[(nr + 1) % IL_F]);
      sem_post(sem);
      printf ("Filozof nr %d (%d raz) je...\n", nr, ii+1);
      sleep (los(1,5));

      printf ("Filozof nr %d (%d raz) po jedzeniu...\n", nr, ii+1);
      pthread_mutex_unlock (&paleczka[(nr + 1) % IL_F]);
      pthread_mutex_unlock (&paleczka[nr]);

      printf ("Filozof nr %d (%d raz) myli...\n", nr, ii+1);
      sleep (los(1,5));
    }
  pthread_cleanup_pop (1);
  return NULL;
}

int main ()
{
  int ii, *nr;
  int flags = O_RDWR|O_CREAT;
  if (0> (sem=sem_open("/semafor",flags,0666,4)))
  {
	  perror("bd tworzenia semafora");
	  exit(1);
  }
  for (ii = 0; ii < IL_F; ii++)
    pthread_mutex_init (&paleczka[ii], NULL);

  for (ii = 0; ii < IL_F; ii++)
    {
      nr = (int *) malloc (sizeof (int));
      *nr = ii;
      pthread_create (&filozofy[ii], NULL, &filozof, nr);
    }
  for (ii = 0; ii < IL_F; ii++)
    pthread_join (filozofy[ii], NULL);
return 0;
}
