/*przyklad zastosowania danych specyficznych watku oraz instrukcji pthread_once */

#include <pthread.h>
#include <stdio.h>
#include <unistd.h>

struct Argumenty
{
  FILE *plik;
  char *msg;
};


pthread_key_t klucz;

static pthread_once_t tylko_raz = PTHREAD_ONCE_INIT;

void init ()
{
  printf("Wolamy init\n");
  pthread_key_create (&klucz, NULL);
}

void * watek_piszacy (void *_argumenty)
{
  struct Argumenty *ar = (struct Argumenty *) _argumenty;
  int ii;

  pthread_once (&tylko_raz, init);
  pthread_setspecific (klucz, ar->plik);
  for (ii = 0; ii < 10; ii++)
    {
    usleep(500000);
/*     fprintf (ar->plik, "%s", ar->msg); */
    fprintf ((FILE*)pthread_getspecific(klucz),"%s", ar->msg);
    }
  if (ar->plik != stdout)
    fclose (ar->plik);
  return NULL;
}

int main ()
{
  pthread_t thread1;
  pthread_t thread2;
  struct Argumenty ar;

  ar.plik = fopen ("out.txt", "w");
  ar.msg = "do pliku\n";
  pthread_create (&thread1, NULL, watek_piszacy, &ar);
/* jezeli pierwszy watek nie zdazy wywolac pthread_setspecific zanim wykonamy zmiany na strukturze ar
to tak jak by nie bylo tej instrukcji. narazie wstawiamy usleep, druga wersja z mutexem */
   usleep(1500000);
  ar.plik = stdout;
  ar.msg = "na ekran\n";
  pthread_create (&thread2, NULL, watek_piszacy, &ar);

  pthread_join (thread1, NULL);
  pthread_join (thread2, NULL);
  pthread_key_delete(klucz);
  return 0;
}
